Attribute VB_Name = "MiscFunctions"
''''''''''''''''''''''''''''''''''''''''''''''''''
'  This code is Copyright 2006 Devo-E.com
'
'  You may use this code to help you develope
'  your own programs for the xbox 360's files
'  but please keep this box in tact.
'
'  Overall ... Have Fun!
'
'  Email: wunsick@team-gx.org
'  Website: www.devo-e.com
'
''''''''''''''''''''''''''''''''''''''''''''''''''
Public Const HEXTYPE = "0123456789ABCDEF"

Public shortTitles(9) As String, Descriptions(9) As String, fullTitle As String
Public internalPNG As String, internalsmPNG As String
Public numFiles As Integer

Public big_Offset As Long, small_Offset As Long, theme_Offset As Long, first_Offset As Long, offset_Gap As Long

'Returns the file's name without the path
Public Function GrabFileName(strWholePath As String) As String
    slshSpot = InStr(strWholePath, "\")
    Do While (slshSpot <> 0)
        strWholePath = Right(strWholePath, Len(strWholePath) - slshSpot)
        slshSpot = InStr(strWholePath, "\")
    Loop
    
GrabFileName = strWholePath
End Function

'Remove characters of value zero when obtaining information that is null-padded
Public Function FilterMe(strInput As String) As String
Dim strReturn As String

    For X = 1 To Len(strInput)
        If (Asc(Mid(strInput, X, 1)) <> 0) Then
            strReturn = strReturn & Mid(strInput, X, 1)
        End If
    Next X
    

    FilterMe = strReturn
    
End Function

'Some shortNames contain characters that Windows does not allow inside of file names,
'so we must use this to filter those characters out when dumping the file's icon
Public Function FilterIllegalChars(strInput As String) As String
Dim strReturn As String, strIllegal As String

strIllegal = "\/:" & Chr(34) & "*?><|"

    For X = 1 To Len(strInput)
        If (InStr(strIllegal, Mid(strInput, X, 1)) = 0) Then
            strReturn = strReturn & Mid(strInput, X, 1)
        End If
    Next X
    
    FilterIllegalChars = strReturn

End Function

'Just one function to combine the steps of converting directly from
'ascii into its decimal equivolent
Public Function TranslateHex(strHex As String) As Long
Dim strRealHex As String

    strRealHex = ConvAsciiToHex(strHex)
    
    TranslateHex = ConvHexToDecimal(strRealHex)

End Function

'Convert normal text into its hex equivolent
'i.e. Chr(65) = 'A'
'Therefore, ConvAsciiToHex("A") would return 41, since
'41 is 65 in hex
Public Function ConvAsciiToHex(strHex As String) As String

For X = 1 To Len(strHex)
    myAscii = Asc(Mid(strHex, X, 1))
    If (myAscii > 0) Then
        Do
            myRem = myAscii Mod 16
            strThisHex = strThisHex & Mid(HEXTYPE, myRem + 1, 1)
            myAscii = Int(myAscii / 16)
        Loop While (myAscii > 0)
        If (Len(strThisHex) < 2) Then strThisHex = strThisHex & "0"
        For Y = Len(strThisHex) To 1 Step -1
            strRealHex = strRealHex & Mid(strThisHex, Y, 1)
        Next Y
        strThisHex = ""
    Else
        strRealHex = strRealHex & "00"
    End If
Next X

ConvAsciiToHex = strRealHex
End Function


'Simple....convert a hexidecimal number to its base-10 equivolent
Public Function ConvHexToDecimal(strRealHex As String) As Long

If (UCase(Left(strRealHex, 2)) = "0X") Then strRealHex = Right(strRealHex, Len(strRealHex) - 2)

    weightVal = 1
    For X = Len(strRealHex) To 1 Step -1
        placeVal = InStr(HEXTYPE, Mid(strRealHex, X, 1)) - 1
        weightVal = 16 ^ (Len(strRealHex) - X)
        result = result + (placeVal * weightVal)
        weightVal = 1
    Next X

    ConvHexToDecimal = result

End Function


'Simple....convert a decimal number to its base-16 equivolent
Public Function ConvDecimalToHex(lgStartDecimal As Long) As String
Dim lgRealDecimal As Long
lgRealDecimal = lgStartDecimal 'We re-declare another long variable because
                               'if we use lgStartDecimal, then VB will modify
                               'the contents of FileInfo, since we passed it as a parameter...

Do
    myRem = lgRealDecimal Mod 16
    hexResult = hexResult & Mid(HEXTYPE, myRem + 1, 1)
    lgRealDecimal = Int(lgRealDecimal / 16)
Loop While (lgRealDecimal > 0)

For X = Len(hexResult) To 1 Step -1
    realResult = realResult & Mid(hexResult, X, 1)
Next X

ConvDecimalToHex = realResult

End Function

'BitShifting - A pain in the ass that is required to get the true locations of the contained files
Public Function BitShift(strBit As String) As String

Dim m_buffer(4) As Long

For X = 1 To 4
    m_buffer(X - 1) = TranslateHex(Mid(strBit, X, 1))
Next X

BitShift = ((((m_buffer(0) And 255) Or (LShiftLong(m_buffer(1), 8))) Or (LShiftLong(m_buffer(2), 16))) Or (LShiftLong(m_buffer(3), 24)))

End Function

Public Sub ExtractFile(filePath As String, offset As Long, size As Long, outFileName As String, myProgBar As ProgressBar)
Dim showProg As Boolean
If (myProgBar = Null) Then showProg = False Else showProg = True

Open filePath For Binary As #1

    Open outFileName For Output As #2
        Print #2, ExtractBinary(offset, size, 1, showProg, myProgBar)
    Close #2
    
Close #1

myProgBar.Value = 0
End Sub

Public Function ExtractBinary(offset As Long, size As Long, fileNum As Integer, showProgress As Boolean, myProgBar As ProgressBar) As String
Dim fileOut As String
Dim num1 As Long

If (showProgress = True) Then myProgBar.Value = 1

If (offset >= first_Offset) Then
    offset = offset + (2 * offset_Gap)
End If
    
If (offset >= big_Offset) Then
    offset = offset + ((Int((offset - big_Offset) / small_Offset) + 1) * offset_Gap)
End If

For X = 0 To (size / 4096) - 1
    If (offset = first_Offset) Then
        offset = offset + (2 * offset_Gap)
    End If
        
    If ((offset >= big_Offset) And (((offset - big_Offset) Mod small_Offset) = 0)) Then
        offset = offset + offset_Gap
    End If

    fileOut = fileOut & BinarySeek(1, offset, 4096)
    offset = offset + 4096
    
    DoEvents
    If (showProgress = True) Then myProgBar.Value = ((4096 * (X + 1)) / size) * 100
Next X

num1 = size - (Int(size / &H1000&) * &H1000&)
fileOut = fileOut & BinarySeek(1, offset, num1)
If (showProgress = True) Then myProgBar.Value = 0

ExtractBinary = fileOut
End Function


Public Function Mult(lsb As Byte, msb As Byte) As Long
    Mult = CLng(lsb + (msb * 256))
End Function

Public Function GetAppPath() As String
If (Len(App.Path) > 3) Then
    GetAppPath = App.Path & "\"
Else
    GetAppPath = App.Path
End If
End Function

Public Function BinarySeek(fileNum As Integer, offset As Long, size As Long) As String
ReDim bContents(size) As Byte

Get #fileNum, offset, bContents()

For X = 1 To size
    BinarySeek = BinarySeek & Chr$(bContents(X))
Next X
End Function

Public Function TextPadding(strPad As String, intLength As Integer) As String
Dim strResult As String

Do While (Len(strPad) > intLength)
    strResult = strResult & Left(strPad, intLength) & vbCrLf
    strPad = Right(strPad, Len(strPad) - intLength)
Loop

strResult = strResult & strPad

TextPadding = strResult
End Function
